** -----------------------------------------------------------------------------
** -----------------------------------------------------------------------------
** This file produces the figures in tables 3 and 4
** -----------------------------------------------------------------------------
** -----------------------------------------------------------------------------


do "paths.do"


** Family types: figures in table 3
** -----------------------------------------------------------------------------

use "$data\BHPS-DataForMoments.dta", replace
keep if wave==12 & sampleS~=1 & inrange(age,19,50)
gen m0k1 = (family==3)
gen m1k1 = (family==4)
gen k0 = (family<=2)

** Family types: table 3
table s, c(mean m0k1 mean m1k1 mean k0 freq) row
more


** Assets by education: figures in table 4
** -----------------------------------------------------------------------------

use "$data\BHPS-DataForMoments.dta", replace

gen rpi = (wave==1)*133.5083333 + (wave==2)*138.4916667 + (wave==3)*140.6583333 ///
         +(wave==4)*144.1416667 + (wave==5)*149.0583333 + (wave==6)*152.7083333 ///
		 +(wave==7)*157.4916667 + (wave==8)*162.875 +(wave==9)*165.4083333 ///
		 +(wave==10)*170.25 + (wave==11)*173.35 + (wave==12)*176.1833333 ///
		 +(wave==13)*181.3166667 + (wave==14)*186.6916667 + (wave==15)*191.975 ///
		 +(wave==16)*198.1083333 + (wave==17)*206.575 + (wave==18)*214.825

gen rhval = hvalue*214.825/rpi
gen rsav  = savings*214.825/rpi
gen rinv  = invests*214.825/rpi
gen rdeb  = debts*214.825/rpi

gen rassets = rsav
replace rassets = rassets+rinv if rinv~=.
replace rassets = rinv if rassets==.
gen passets = (rassets>0) if rassets~=.

gen rnet = rassets
replace rnet = rnet-rdeb if rdeb~=.
gen pdebts  =  (rassets>rnet)
gen pnet = (rnet>0) if rassets~=.

gen howner = (hown<=2) if hown~=.

** Financial assets: table 4
table s, c(mean passets mean rnet p10 rnet p90 rnet)
** Housing: table 4
table s, c(mean howner mean rhval p10 rhval p90 rhval)




