** -----------------------------------------------------------------------------
** -----------------------------------------------------------------------------
** This file uses model simulations to to plot consumption value of uncertainty
** and plot figure 10
** -----------------------------------------------------------------------------
** -----------------------------------------------------------------------------


cap program drop sensitivity
program define sensitivity		

	forvalues r=1/9 {
		
		gen eCwl`r' = 100 * ( 1 - (EVwl0/EVwl`r')^(-1/0.56) )
		global varlist "wl"
		
		foreach var of global varlist {
			sum eC`var'`r'
			global eC`var'`r' = r(mean)

			centile eC`var'`r', c(0.1,99.9)
			local c1=r(c_1)
			local c2=r(c_2)
			sum eC`var'`r' if inrange(eC`var'`r', `c1', `c2')
			global eC`var'_trim`r' = r(mean)
			gen eC`var'_trim`r'=eC`var'`r' if inrange(eC`var'`r', `c1', `c2')

			forvalues s=1/3 {
				sum eC`var'`r' if educ0==`s'
				global eC`var'`r's`s' = r(mean)
				sum eC`var'_trim`r' if educ0==`s'
				global eC`var'_trim`r's`s' = r(mean)
			}
		}
	}

	drop _all
	set obs 9
	gen var = 0.4+(_n-1)*0.2
	global varlist "eCwl eCwl_trim"
	foreach var of global varlist {
		cap drop `var'*
		gen `var'=.
		forvalues r=1/9 {
			replace `var' = ${`var'`r'} if _n==`r'
		}
		forvalues s=1/3 {
			gen `var's`s'=.
			forvalues r=1/9 {
				replace `var's`s' = ${`var'`r's`s'} if _n==`r'
			}
		}
	}

end


do "paths.do"

local year = 2002
use "$sim\risk.dta", clear
qui sensitivity
twoway line eCwls1 eCwls2 eCwls3 var, graphregion(fcolor(white)) color(navy pink lavender) ///
	legend(label(1 "secondary") label(2 "high school") label(3 "university") rows(1) region(lcolor(none))) lpattern(solid dash solid) ///
	ytitle("% change in consumption") xtitle("variance of innovations in female wage rates") 

		
