! Calculate taxes and benefits for an example family

program main

    use fortax_type,       only :  sys_t, fam_t, net_t, fam_gen
    use fortax_prices,     only :  sysindex_t, loadsysindex, getsysindex, loadindex, upratesys, upratefactor
    use fortax_read,       only :  readFortaxParams
    use fortax_calc
    use fortax_kinks
    
    implicit none

    type(sys_t)                 :: sys
    type(fam_t)                 :: fam
    type(net_t)                 :: net
    type(sysindex_t)            :: sysindex
    integer(4)                  :: sysnum
    character(255)              :: sysfilepath
    character(255)              :: rpifilepath
    real(8)                     :: upratefac
    integer(4)                  :: sysdate
    integer(4)                  :: newdate



    sysdate = 19950925
    newdate = 20080101

    
    ! Load tax system index (records which tax system was in place when)
    call loadsysindex(sysindex,'../fortax/systems/sysindex.csv')

    ! Get the file path for the tax system in place on the specified date
    call getsysindex(sysindex,sysdate,'fortax',sysfilepath,sysnum)
    sysfilepath = '../fortax/'//sysfilepath


    ! Read in the tax system
    call readFortaxParams(sys,sysfilepath)

    ! Load RPI
    rpifilepath = '../fortax/prices/rpi.csv'
    call loadindex(rpifilepath)

    ! Calculate uprating factor
    upratefac = upratefactor(sysdate,newdate)

    
    ! Uprate
    call upratesys(sys,upratefac,newdate)


    ! Set family characteristics and pre-tax income
!    fam = fam_gen(kidage=(/4/),hrs1=5.0_8,earn1=15.0_8,rent=50.0_8)    
!    fam = fam_gen(age1=25, age2=30, hrs1=1.0_8, earn1=18.0_8, couple=.true., married=.true., kidage=(/5/), maint=150.0_8)
  fam = fam_gen(age1=25, age2=25, hrs1=0.0_8, hrs2=25.0_8, earn1=0.0_8, earn2=300.0_8, married=.true.)
  fam = fam_gen(age1=25, hrs1=0.0_8)

  call CalcNetInc(sys,fam,net)



end program main