* This do file draws Figures 1 and 2
************************************


* Change this to the location where "\fortaxcalcs\figures\" is saved
global fileloc "C:\Users\jonathan_s\Documents\fortran\fortaxcalcs\figures"

* Open the data
use "$fileloc\dataforfigures.dta", clear




************
* FIGURE 1 *
************


* Lone parent: 4 year old kid, 0 childcare, 0 rent (tax credit + net income)
******************************************************************************

* (This is group 2)

* 1999, IS reform, WFTC reform
*-----------------------------


* IS+TC award alongside the budget constraint


# delimit ;
line dispincWFIK_grp2 dispincWFTC_grp2 dispinc1999_grp2 hrs if hrs <= 50,
	lcolor(gs8 gs0 gs13)
	lwidth(medthick ..)
	graphregion(color(white))
	ytitle("Net family income (pw)")
	xtitle("Hours of work (pw)")
	title("Net family income (pw)", color(black))
	legend(label(1 "IS reform") label(2 "WFTC reform") label(3 "1999") order(3 1 2) rows(1) region(lcolor(white)) span)
	scale(*1.2)
	yscale(range(0 400))
	ylabel(#5, glcolor(gs0) glwidth(thin))
	name(lp_ntinc, replace)
	nodraw
	;
# delimit cr


gen double baseline   = incsup1999_grp2 + fc1999_grp2
gen double isreform   = incsupWFIK_grp2 + fcWFIK_grp2 if hrs <= 16
gen double wftcreform = incsupWFIK_grp2 + fcWFIK_grp2 if hrs >= 16


# delimit ;
line isreform wftcreform baseline hrs if hrs <= 50,
	lcolor(gs8 gs0 gs13)
	lwidth(medthick ..)
	graphregion(color(white))
	ytitle("IS + tax credit award (pw)")
	xtitle("Hours of work (pw)")
	title("IS and tax credit award (pw)", color(black))
	legend(label(1 "IS reform") label(2 "WFTC reform") label(3 "1999") order(3 1 2) rows(1) region(lcolor(white)) span)
	scale(*1.2)
	yscale(range(0 150))
	ylabel(#5, glcolor(gs0) glwidth(thin))
	name(lp_award, replace)
	nodraw
	;
# delimit cr

# delimit ;
grc1leg lp_award lp_ntinc,
	graphregion(color(white))
	imargin(0 0 0 0)
	legendfrom(lp_ntinc)
	name(lp, replace)
	;
# delimit cr
graph display lp, xsize(6)
graph export "$fileloc\lp.eps", name(lp) replace
graph drop lp_award lp_ntinc
drop baseline isreform wftcreform




************
* FIGURE 2 *
************


* Couple, male working 40 hours, 4 year old kid, 0 childcare, 0 rent
**********************************************************************

* This is group 8



* 1999, IS reform, WFTC reform
*-----------------------------


* IS+TC award alongside the budget constraint


# delimit ;
line dispincWFTC_grp8 dispinc1999_grp8 hrs if hrs <= 50,
	lcolor(gs0 gs13)
	lwidth(medthick ..)
	graphregion(color(white))
	ytitle("Net family income (pw)")
	xtitle("Hours of work (pw)")
	title("Net family income (pw)", color(black))
	legend(label(1 "WFTC reform") label(2 "1999") order(2 1) rows(1) region(lcolor(white)) span)
	scale(*1.2)
	yscale(range(0 400))
	ylabel(#5, glcolor(gs0) glwidth(thin))
	name(cou40_ntinc, replace)
	nodraw
	;
# delimit cr


gen double baseline   = incsup1999_grp8 + fc1999_grp8
gen double wftcreform = incsupWFIK_grp8 + fcWFIK_grp8


# delimit ;
line wftcreform baseline hrs if hrs <= 50,
	lcolor(gs0 gs13)
	lwidth(medthick ..)
	graphregion(color(white))
	ytitle("IS + tax credit award (pw)")
	xtitle("Hours of work (pw)")
	title("IS and tax credit award (pw)", color(black))
	legend(label(1 "WFTC reform") label(2 "1999") order(2 1) rows(1) region(lcolor(white)) span)
	scale(*1.2)
	yscale(range(0 150))
	ylabel(#5, glcolor(gs0) glwidth(thin))
	name(cou40_award, replace)
	nodraw
	;
# delimit cr

# delimit ;
grc1leg cou40_award cou40_ntinc,
	graphregion(color(white))
	imargin(0 0 0 0)
	legendfrom(cou40_ntinc)
	name(cou40, replace)
	;
# delimit cr
graph display cou40, xsize(6)
graph export "$fileloc\cou40.eps", name(cou40) replace
graph drop cou40_award cou40_ntinc
drop baseline wftcreform








